# configure paths for libsay2
# robey, apr 2001

dnl AM_PATH_SAYTWO([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl Test for libsay2, and define SAY2_CFLAGS and SAY2_LIBS
dnl
AC_DEFUN(AM_PATH_SAYTWO,
[dnl
dnl Poke around for enaml.h
dnl
AC_ARG_WITH(say2-include, [  --with-say2-include=DIR  Location of libsay2 include files],
	    [ say2_include_dir="$withval", say2_include_dir="" ])
AC_ARG_WITH(say2-lib,     [  --with-say2-lib=DIR      Location of libsay2 libraries],
	    [ say2_lib_dir="$withval", say2_lib_dir="" ])

min_say2_version=ifelse([$1], ,0.5.0,$1)
AC_MSG_CHECKING(for libsay2 - version >= $min_say2_version)

dnl wierd and whacky (thanks, answer) :)
find_file_in_dirs_and_set() {
    fdis_var=${1}
    fdis_file=${2}
    shift 2

    for fdis_tmp do
        if test -d $fdis_tmp -a -f "$fdis_tmp/$fdis_file"; then
            eval "$fdis_var=$fdis_tmp"
            return 0
        fi
    done
          
    eval "$fdis_var=''"
    return 1
}

# look for possible libsay2-(version) directory near us
say2_possible=`pwd`/`ls -d ../libsay2*/. 2>/dev/null | tail -1`

if test x$say2_include_dir = x; then
    find_file_in_dirs_and_set "say2_include_dir" "say2/say2.h" "$say2_possible" "/usr/include" "/usr/local/include" "`pwd`/../lib" "`pwd`/../../../lib"
fi
if test x$say2_lib_dir = x; then
    find_file_in_dirs_and_set "say2_lib_dir" "libsay2.a" "$say2_possible/say2" "/lib" "/usr/lib" "/usr/local/lib" "`pwd`/../lib/say2" "`pwd`/../../../lib/say2"
fi
find_file_in_dirs_and_set "say2_config_dir" "say2-config" "/usr/bin" "/usr/local/bin" "`pwd`/../lib/say2" "`pwd`/../../../lib/say2" "$say2_lib_dir"

if test -x $say2_config_dir/say2-config; then
    SAY2_CFLAGS=`$say2_config_dir/say2-config --cflags`
    SAY2_LIBS=`$say2_config_dir/say2-config --libs`
else
    AC_MSG_ERROR([Can't find say2-config.])
    SAY2_CFLAGS=""
    SAY2_LIBS=""
fi

if test "x$say2_include_dir" = "x"; then
    AC_MSG_ERROR([Can't find say2.h header file.])
fi

SAY2_CFLAGS="$SAY2_CFLAGS -I$say2_include_dir"
SAY2_LIBS="-L$say2_lib_dir -lsay2 $SAY2_LIBS"

ac_save_CFLAGS="$CFLAGS"
ac_save_LIBS="$LIBS"
CFLAGS="$CFLAGS $SAY2_CFLAGS"
LIBS="$GLIB_LIBS $SAY2_LIBS"

AC_TRY_RUN([
#include <stdio.h>
#include <stdlib.h>
#include <say2/say2.h>

#ifndef SAY2_VERSION_MICRO
#define SAY2_VERSION_MICRO 0
#endif

int
main (int argc, char **argv)
{
        char *version = strdup("$min_say2_version");
        int major, minor, micro;

        if (sscanf (version, "%d.%d.%d", &major, &minor, &micro) != 3) {
                printf ("\nbad version string.\n");
		return 1;
        }
	if ((SAY2_VERSION_MAJOR == major) &&
	    (SAY2_VERSION_MINOR >= minor) &&
            (SAY2_VERSION_MICRO >= micro)) {
	        return 0;
        }
        printf ("\n*** BAD: found libsay2 version %d.%d.%d, not %d.%d.%d\n",
	        SAY2_VERSION_MAJOR, SAY2_VERSION_MINOR, SAY2_VERSION_MICRO, major, minor, micro);
        return 1;
}
],, no_say2=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])

CFLAGS="$ac_save_CFLAGS"
LIBS="$ac_save_LIBS"

if test "x$no_say2" = x; then
    AC_MSG_RESULT(yes)
    ifelse([$2], , :, [$2])
else
    AC_MSG_RESULT(no)
    SAY2_CFLAGS=""
    SAY2_LIBS=""
    ifelse([$3], , :, [$3])
fi
AC_SUBST(SAY2_CFLAGS)
AC_SUBST(SAY2_LIBS)
])
