/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * connect_values.h
 * -- 
 * $Id: connect_values.h,v 1.1 2001/06/04 11:57:50 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_CONNECT_VALUES_H
#define _MEKO_CONNECT_VALUES_H

/* Required includes */
#include <glib.h>

/* Structure that holds the values a connection dialog asks for */
typedef struct _connect_values ConnectValues;
struct _connect_values {
	gchar *server_name;
	gchar *server_port;
	gchar *nickname;

	gboolean as_guest;

	gchar *password;
	gchar *email;
	gchar *tagline;
};

/* Create and free ConnectValues structures */
ConnectValues *connect_values_new(void);
ConnectValues *connect_values_new_from(ConnectValues *);
void           connect_values_free(ConnectValues *);

#endif /* !_MEKO_CONNECT_VALUES_H */
